function DesempenhoDeCompras_Controller(General, ScreenService, localStorageEngine, MessageService) {

    var self = this;
    
    this.validaData = function(dtInicial, dtFinal) {        
        var dataInicial = dtInicial ? moment(dtInicial, 'MM/YYYY')._d : null;        
        var dataFinal = dtFinal ? moment(dtFinal, 'MM/YYYY')._d : null;   

        if (dataFinal < dataInicial) {           
            MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
            return false;                           
        }
        return true;                                
    };
    
    this.validaPeriodo = function(dtInicial, dtFinal){
        var maxData = moment(dtInicial, "MM/YYYY");   
        var datFin = moment(dtFinal, "MM/YYYY");
        
        if(self.validaData(dtInicial, dtFinal) === false){
            return false;
            
        }else{
            datFin = datFin.endOf('month').format("DD/MM/YYYY");
            datFin = datFin ? moment(datFin, "DD/MM/YYYY")._d : null;
            maxData = maxData.add(13, 'month').format("DD/MM/YYYY");
            maxData = moment(maxData, "DD/MM/YYYY");
            maxData = maxData.startOf('month').format("DD/MM/YYYY");
            maxData = maxData ? moment(maxData, "DD/MM/YYYY")._d : null;
            
            if(datFin > maxData){
                MessageService.showMessageByCode("PER_ANALISE_MAIOR_13");
                return false;
            }
            return true;
        }
    };
    
    this.setDataDefault = function(widget){
        var datatual = moment().format('MM/YYYY');
        var ano = datatual.split('/')[1];
        ano--;
        var ini = ['01', ano].join("/");
        var fin = ['12', ano].join("/");
        
        widget.getField('MESINIREF').value(ini);
        widget.getField('MESFINREF').value(fin);
    };
    
    this.selecionaFiltro = function(widget){
        var row = widget.currentRow;
        
        if(row.SELECIONAFILTRO == '1'){
            widget.getField('GRUPUNI').isVisible = true;
            widget.getField('REGIONAL').isVisible = false;
            widget.getField('UNIDADE').isVisible = false;
            widget.getField('REGIONAL').value('');
            widget.getField('UNIDADE').value('');
            
        }else if(row.SELECIONAFILTRO == '2'){
            widget.getField('GRUPUNI').isVisible = false;
            widget.getField('REGIONAL').isVisible = true;
            widget.getField('UNIDADE').isVisible = false;
            widget.getField('GRUPUNI').value('');
            widget.getField('UNIDADE').value('');
            
        }else{
            widget.getField('GRUPUNI').isVisible = false;
            widget.getField('REGIONAL').isVisible = false;
            widget.getField('UNIDADE').isVisible = true;
            widget.getField('REGIONAL').value('');
            widget.getField('GRUPUNI').value('');
        }
        
        
    };
    
    this.setValorPHP = function(field){
        if(!field){
            return 'T';
        }else{
            return field;
        }
    };
    
    this.setDatIni = function(field){
        var inicioDoMes = moment(field, "MM/YYYY");
        return inicioDoMes.startOf('month').format("DD/MM/YYYY");
    };
    
    this.setDatFin = function(field){
        var fimDoMes = moment(field, "MM/YYYY");
        return fimDoMes.endOf('month').format("DD/MM/YYYY");
    };
    
    this.abreRelatorio = function(widget, currentRow, reportName) {
        widget.currentRow.P_CDAREAGERE = self.setValorPHP(currentRow.CDAREAGERE);
        widget.currentRow.P_CDGRUPFILI = self.setValorPHP(currentRow.CDGRUPFILI);
        widget.currentRow.P_CDFILIAL = self.setValorPHP(currentRow.CDFILIAL);
        widget.currentRow.P_DATA_REF_INICIAL = self.setDatIni(currentRow.MESINIREF);
        widget.currentRow.P_DATA_REF_FINAL = self.setDatFin(currentRow.MESFINREF);
        widget.currentRow.P_DATA_INICIAL = self.setDatIni(currentRow.MESINIANA);
        widget.currentRow.P_DATA_FINAL = self.setDatFin(currentRow.MESFINANA);
        widget.currentRow.NRORG = getLocalVar('NRORG');
        widget.currentRow.CDOPERADOR = getLocalVar('CDOPERADOR');
        

   	    General.openReport('cmp_solicitacao_relatorios#/desempenho_de_compras_relatorio', reportName, currentRow);  
    };
    
    this.criaRelatorio = function(widget) {

        var reportName  = widget.currentRow.REPORT_NAME;      
        if (widget.isValid() && this.validaPeriodo(widget.currentRow.MESINIANA, widget.currentRow.MESFINANA) && this.validaData(widget.currentRow.MESINIREF, widget.currentRow.MESFINREF)) {    
            General.openReportPopup(widget, this.abreRelatorio, [widget, widget.currentRow, reportName]);  
        }
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('DesempenhoDeCompras_Controller', DesempenhoDeCompras_Controller);
});